using Godot;


public class Raycaster : Camera {
  bool doRayCast = false;
  Vector3 from;
  Vector3 to;

  public override void _PhysicsProcess(float delta) {
    if (doRayCast) {
      var spaceState = GetWorld().DirectSpaceState;
      var hit = spaceState.IntersectRay(from, to);

      if (hit.Contains("rid")) {
        Debug.Log(hit["rid"]);
      }
      doRayCast = false;
    }
  }

  public override void _UnhandledInput(InputEvent e) {
    if (e is InputEventMouseButton mouseButtonEvent) {
      if (mouseButtonEvent.Pressed && mouseButtonEvent.ButtonIndex == (int)ButtonList.Left) {
        from = this.ProjectRayOrigin(mouseButtonEvent.Position);
        to = from + this.ProjectRayNormal(mouseButtonEvent.Position) * 1000f;
        doRayCast = true;
      }
    }
  }
}
